#<profile4xi profile = "31"/>
#<target4xi target = "build2hyperlink4size.py">
#<abstract4xi abstract = "builds hyperlinks for photos with required size"/>
#<refer4xi reference = "version4xi.py>
#<note4xi note = "both embeds control attributes and also uses version4xi.py"/>
# -------------------------------------------------------------------------------------------------
#<use4xi usage = "
#
# 01) go to Studio4Xi in commmand mode
#       > go3studio4fb    <-- Python 3 version of Studio4Xi in Fastblack workstation
#       > go3studio4riika <-- Python 3 version of Studio4Xi in RiikaPC   workstation
#       TIP: you could use the same go2studio4xi-command in all workstations just varying the content! 
#
# 02) see build2hyperlink4size.py
#         build2hyperlink4alpha.py
#         build2hyperlink4content.py
#
# 03) see version4xi.py
#         - build2hyperlink4all.py
#         - build2hyperlink4alpha.py
#         - build2hyperlink4size.py 
#         - build2hyperlink4content.py
#
# 04) set ack2all4size (if necessary)
#
# 05) set ack2debug4hyperlink (if necessary)
#
# 06) set ack2rename4output (if necessary)
#
# 07) >> build2hyperlink4size  <-- run it!
#
# 08) test created local HTML file
# 
# 10) ftp upload hyperlinks for alpha 
# 
# 11) test and use alpha hyperlinks
#     TIP: >>  https://www.yourdragonxi.org/stock4xi/photo2view4yo.html  <-- photos
# 
# 12) take backups 
#
# TIPS:
#     rename2hyperlink4content.py <-- rename photos loaded from camera
#     build2hyperlink4alpha.py    <-- build alphabet level such as c or v
#     build2hyperlink4all.py      <-- build hyperlinks to all
#"  
#/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'build2hyperlink4size' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os,sys,string
from shutil import copyfile

#"
#/>

# -------------------------------------------------------------------------------------------------
# Studio4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi 
from version4xi import ROOT4XI   

#"
#/>
# -------------------------------------------------------------------------------------------------
# Multiprocessing4xi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import time4xi
from actor2a4xi import Actor2a4Xi                                                                                  
from actor2b4xi import Actor2b4Xi                                                                                   
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi
from pickle4xi import pickle4xi                                                                                   
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 
from pipe4xi import Pipe4Xi   
from print4xi import print4xi
from print4xi import Print4Xi 
from process4xi import Process4Xi
from queue4xi import Queue4Xi
from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# Globals                            
# -------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global ack2all4size
global ack2rename4output

global base2build4hyperlink

global count2ack4hyperlink
global count2nack4hyperlink
global count2found4hyperlink

global current2series4hyperlink
global candidate2series4hyperlink

global fileobject4size 
global fileobject4hyperlink
global ftp2upload4size
global folder2build4hyperlink
global folder2build4size

global kb2size4size
global keys2size4size
global keys2profile4hyperlink
global key2profile4hyperlink

global left2find

global mean2size4ack
global min2size4ack
global sum2size4ack

global max2size4ack    
global max2size4file 
global mean2size4ack

global new2name4content
global new2path4content

global kb2fetch                              # knowledgebase for fetching
global keys2profile

global path2read4xi                          # path for input source targets
global PickleKB4Xi
global profile2fetch

global right2find

global size2image4size
global sum2size4ack

global t2xi 
global trace_object_count

global kb2extension                          
global kb2alpha
global kb2dir
global kb2file

#"
#"/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2all4size = False                                                    # False: build only one specified size
ack2rename4output = True                                                # False: index2xxxxxxxx4yo.html will be the output file
folder2build4size     = VersionKB4Xi['all2image4size']                  # 
size2image4size       = VersionKB4Xi['size2image4size']                 #
ftp2upload4size       = VersionKB4Xi['ftp2upload4size']                 # 
base2build4hyperlink  = VersionKB4Xi['base2build4size']                 #

kb2size4size = {}
kb2size4size [1] = 'cam'
kb2size4size [2] = 'l2s'
kb2size4size [3] = 'large'
kb2size4size [4] = 'm2s'
kb2size4size [5] = 'medium'
keys2size4size = kb2size4size.keys()

left2find = '('

max2size4file = VersionKB4Xi['maxsize2file4dragon']

max2size4ack  = 0
mean2size4ack = 0
min2size4ack  = 0

new2name4content = None
new2path4content = None

count2ack4hyperlink   = 0
count2nack4hyperlink  = 0
count2found4hyperlink = 0

current2series4hyperlink = "current2series4dragon5dummy"
candidate2series4hyperlink  = "candidate2series4dragon5dummy"

path2read4xi  = VersionKB4Xi['all2image4size'] + VersionKB4Xi['size2image4size']
                          
profile2fetch = {}
profile2fetch [1] = '.JPG'                             # object types to be aceepted for hyperlinks
profile2fetch [2] = '.jpg'
keys2profile4hyperlink = profile2fetch.keys()

right2find = ')'

sum2size4ack  = 0


PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 

#"
#"/>



# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4fecth" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4fecth():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4FECTH - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4FECTH - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4FECTH - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # APU2Buffer4Xi; APU2CommandQueue4Xi ... finish2commandqueue4bpu; finish2commandqueue4apu ...
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4FECTH - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4fetch" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4fetch():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4FECTH: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4FECTH - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4FECTH - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4FECTH - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4FECTH - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4FECTH - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4FECTH *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4FECTH - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4FECTH - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4FECTH - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4FECTH - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         # 'Pipe4Xi': 'NACK4TRACE',
         # 'Queue4Xi': 'NACK4TRACE',         
         # 'Process4Xi': 'NACK4TRACE',
         'build2hyperlink4size': 'NACK4TRACE'
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # Pipe4Xi, Process4Xi, Queue4Xi, build2hyperlink4size

    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
     
#</function4xi>             
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print-trace4xi" usage = "
#   print XML trace
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):

    class2print  = "build2hyperlink4size"
    method2print = "build2hyperlink4size" 
        
    # message2print = "{passed" + "; t2xi-passed-to-print-trace4xi: " + str(t2xi) + "; time: " + time4xi() + "}"
    # print4xi(class2print, method2print, message2print)   
    #    

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..//..//..//..//web//xml//sense-build2hyperlink4size.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4apu.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/web/lib/owl/multiprocessing4apu.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing build2hyperlink4size.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">build2hyperlink4size sensed.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..//..//..//..//web//xml//reason-build2hyperlink4size.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4apu.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4apu.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for build2hyperlink4size.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..//..//..//..//web//xml//ace-build2hyperlink4size.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4apu.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4apu.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for build2hyperlink4size.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of build2hyperlink4size.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "build2hyperlink4size" usage = "
#   builds hyperlinks
#"> 
# -------------------------------------------------------------------------------------------------
def build2hyperlink4size(target2explore4hyperlink):

    global candidate2series4hyperlink
    global current2series4hyperlink    
    
    global count2ack4hyperlink
    global count2nack4hyperlink
    global count2found4hyperlink
     
    
    global fileobject4size
    global fileobject4hyperlink 
    global folder2build4size
    global ftp2upload4size
       
    global keys2profile4hyperlink
    global key2profile4hyperlink
    
    global left2find

    global max2size4file    
    global max2size4file     
    global max2size4ack    
    global mean2size4ack
    global min2size4ack
 
    global new2name4content
    global new2path4content   
    
    global path2read4xi
    global profile2fetch                         # extension for files
    
    global right2find
    
    global size2image4size
    global sum2size4ack    

       
    # ---------------------------------------------------------------------------------------------
    # INITIALIZE
    # ---------------------------------------------------------------------------------------------      
    ack2debug4hyperlink = True                   # <-- True
    count2found4hyperlink = count2found4hyperlink + 1
    
    # ---------------------------------------------------------------------------------------------
    # SPLIT TARGET NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2target=os.path.splitext(target2explore4hyperlink)
    
    ack2profile = False
    for key2profile4hyperlink in keys2profile4hyperlink:
        if name2target[1] == profile2fetch[key2profile4hyperlink]:                                                             
            ack2profile = True

    if ack2profile is True:     
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF BUILD2HYPERLINK4SIZE - TARGET
        # -----------------------------------------------------------------------------------------
        path2input = target2explore4hyperlink
        if ack2debug4hyperlink is True:
            print("(STEP 0A1/33) OF BUILD2HYPERLINK4SIZE - TARGET2EXPLORE4HYPERLINK: ", target2explore4hyperlink) 
            # E://DRAGONXI//WebFaction//Web533//FTPWeb533//home//icefellow//webapps//yodragonxiorg//web//temp//images//l2s//w\winter\winter-06december2016-v\winter-06december2016-v(01).JPG
            
        # ==========================================================================================================
        # create hyperlink to image
        # ==========================================================================================================
        url2web4hyperlink = target2explore4hyperlink
        if ack2debug4hyperlink is True:
            print("(STEP 1A/33) OF BUILD2HYPERLINK4SIZE - URL2WEB4HYPERLINK: ", url2web4hyperlink) 
            # E://DRAGONXI//WebFaction//Web533//FTPWeb533//home//icefellow//webapps//yodragonxiorg//web//temp//images//l2s//w\winter\winter-06december2016-v\winter-06december2016-v(01).JPG
            
        ack2all4web = False
        string2edit = '\\'
        string2use = '/'
        while 1:
            if ack2all4web is True:
                break
            else:
                index2edit=str.find(url2web4hyperlink,string2edit)   
                if index2edit == -1:
                    ack2all4web = True
                else:
                    url2web4hyperlink = url2web4hyperlink[0:index2edit] + string2use + url2web4hyperlink[index2edit+1:]
                        
        name2web=os.path.splitext(url2web4hyperlink)
        shortname2web4hyperlink = name2web[0]
        if ack2debug4hyperlink is True:
            print("(STEP 1B/33) OF BUILD2HYPERLINK4SIZE - SHORTNAME2WEB4DRAGON: ", shortname2web4hyperlink)
            # E://DRAGONXI//WebFaction//Web533//FTPWeb533//home//icefellow//webapps//yodragonxiorg//web//temp//images//l2s//w/winter/winter-06december2016-v/winter-06december2016-v(01)
            
        string2find4hyperlink = '/'
        ackall2found4hyperlink = False           
            
        while 1:
            if ackall2found4hyperlink is True:
                break
            else:
                index2find4hyperlink=str.find(shortname2web4hyperlink,string2find4hyperlink)   
                if index2find4hyperlink == -1:
                    ackall2found4hyperlink = True
                else:
                    shortname2web4hyperlink = shortname2web4hyperlink[index2find4hyperlink+1:]
                        
        if ack2debug4hyperlink is True:            
            print("(STEP 1C/33) OF BUILD2HYPERLINK4SIZE - SHORTNAME2WEB4DRAGON: ", shortname2web4hyperlink)
            # winter-06december2016-v(01)
                
        ackall2found4hyperlink = False 
        print("(STEP 1D/33) OF BUILD2HYPERLINK4SIZE - ACKALL2FOUND4HYPERLINK: ", ackall2found4hyperlink)
        # False
            
        while 1:
            if ackall2found4hyperlink is True:
                break
            else:
                index2left4hyperlink=str.find(shortname2web4hyperlink,left2find)
                if index2left4hyperlink == -1:
                    current2series4hyperlink = shortname2web4hyperlink
                    if ack2debug4hyperlink is True:
                        print("(STEP 2A/33) OF BUILD2HYPERLINK4SIZE - CURRENT2SERIES4DRAGON: ", current2series4hyperlink) 
                        # 
                    ackall2found4hyperlink = True
                         
                else:
                    index2right4hyperlink=str.find(shortname2web4hyperlink,right2find)
                    if index2right4hyperlink == -1:
                        ackall2found4hyperlink = True 
                    else:
                        candidate2series4hyperlink = shortname2web4hyperlink[0:index2left4hyperlink]
                            
                        index3find4hyperlink=str.find(shortname2web4hyperlink,current2series4hyperlink)
                        if index3find4hyperlink == -1:
                                
                            current2series4hyperlink = candidate2series4hyperlink
                            if ack2debug4hyperlink is True:
                                print("(STEP 2B/33) OF BUILD2HYPERLINK4SIZE - CURRENT2SERIES4DRAGON: ", current2series4hyperlink) 
                                # winter-06december2016-v
                                
                            count2found4hyperlink = 0
                            fileobject4hyperlink.write('<br />' + '\n')
                        else:
                            shortname2web4hyperlink = shortname2web4hyperlink[index2left4hyperlink:index2right4hyperlink+1]
                            if ack2debug4hyperlink is True:
                                print("(STEP 2C/33) OF BUILD2HYPERLINK4SIZE - SHORTNAME2WEB4DRAGON: ", shortname2web4hyperlink)
                                # 
                            count2found4hyperlink = count2found4hyperlink + 1
                            if count2found4hyperlink >= max2size4file:
                                count2found4hyperlink = 0
                            else:
                                pass        

                        ackall2found4hyperlink = True
            
               
        # =======================================================================================================================
        # 
        # =======================================================================================================================                    
                     
        if base2build4hyperlink is None:
            # ===================================================================================================================
            # LOCAL URL
            # ===================================================================================================================
            if ack2debug4hyperlink is True:
                print("(STEP 3A1/33) OF BUILD2HYPERLINK4SIZE - LOCAL URL, BASE2BUILD4HYPERLINK: ", base2build4hyperlink) 
                # 
            
            fileobject4hyperlink.write('<br /><b>&raquo;</b><a href="' + url2web4hyperlink + '" target="_blank">' + shortname2web4hyperlink + '</a>\n')                       
                
        else:
            # ===================================================================================================================
            # WEB URL
            # ===================================================================================================================            
            if ack2debug4hyperlink is True:
                print("(STEP 3A2/33) OF BUILD2HYPERLINK4SIZE - COMING TO DECIDE WEB URL - TIME: ", time4xi())
                # yes
            try:  
                base2local4hyperlink = path2read4xi
                if ack2debug4hyperlink is True:
                    print("(STEP 3B0/33) OF BUILD2HYPERLINK4SIZE - WEB URL IT WILL BE, BASE2LOCAL4HYPERLINK: ", base2local4hyperlink) 
                    # E://DRAGONXI//WebFaction//Web533//FTPWeb533//home//icefellow//webapps//yodragonxiorg//web//temp//images//l2s//
                    
 
            except:
                    print("(STEP 3Z1/33) OF BUILD2HYPERLINK4SIZE - FAILED : ", time4xi()) 
                    # 
            try:
                print("(STEP 3B1/33) OF BUILD2HYPERLINK4SIZE - URL2WEB4HYPERLINK: ", url2web4hyperlink) 
                # 
                
            except:
                print("(STEP 3Z2/33) OF BUILD2HYPERLINK4SIZE - FAILED : ", time4xi()) 
                #     
            try:
                print("(STEP 3B2/33) OF BUILD2HYPERLINK4SIZE - BASE2BUILD4HYPERLINK: ", base2build4hyperlink) 
                # https://www.yourdragonxi.org/web/temp/images//l2s//
                
            except:
                print("(STEP 3Z2/33) OF BUILD2HYPERLINK4SIZE - FAILED : ", time4xi()) 
                #     
      
            ack2localtries4hyperlink = False                   
            while 1:
                if ack2localtries4hyperlink is True:
                    break
                else:
                    index2find4hyperlink=str.find(url2web4hyperlink,base2local4hyperlink)            
                    # 
                    #  
                    if index2find4hyperlink == -1:
                        ack2localtries4hyperlink = True
                    else:
                        if ack2debug4hyperlink is True:
                            print("(STEP 3B/33) OF BUILD2HYPERLINK4SIZE - BASE2BUILD4DRAGON: ", base2build4hyperlink)
                            # https://www.yourdragonxi.org/web/temp/images//l2s//
                        url2web4hyperlink = base2build4hyperlink + url2web4hyperlink[len(base2local4hyperlink):]
                        if ack2debug4hyperlink is True:
                            print("(STEP 3C/33) OF BUILD2HYPERLINK4SIZE - URL2WEB4HYPERLINK: ", url2web4hyperlink)
                            # https://www.yourdragonxi.org/web/temp/images//l2s//w/winter/winter-06december2016-v/winter-06december2016-v(01).JPG
                        
                        if count2found4hyperlink < 1: 
                            fileobject4hyperlink.write('<br /><b>&raquo;</b><a href="' + url2web4hyperlink + '" target="_blank">' + shortname2web4hyperlink + '</a>' + '\n')
                        else:
                            fileobject4hyperlink.write('<b>&raquo;</b><a href="' + url2web4hyperlink + '" target="_blank">' + shortname2web4hyperlink + '</a>\n')                            
                        ack2localtries4hyperlink = True 

    else:
        
        count2nack4hyperlink = count2nack4hyperlink + 1
        
                    
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   reviewing all tests
#">                           
# -------------------------------------------------------------------------------------------------
def main():
    global ack2rename4output

    global count2ack4hyperlink
    global count2nack4hyperlink
    global count2found4hyperlink
    global count2found4hyperlink
    
    global fileobject4hyperlink
    global folder2build4size
    
    global max2size4ack    
    global mean2size4ack
    global min2size4ack
    
    global new2name4content
    global new2path4content   
    
    global size2image4size
    global sum2size4ack    
    global sum2size4ack    
        
    global max2size4file 
    global dimension2expect4image
    global dimension2store4stats    
            
    global path2read4xi
    global profile2fetch

    global t2xi
    global trace_object_count    

                       
    # ------------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # -------------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 0A1/33) OF MAIN BUILD2HYPERLINK4SIZE - SET T2XI TO: ", t2xi)
    # SET T2XI TO:  <print4xi.Print4Xi object at 0x02E309F0>
    
    set2trace4fecth()                                                                                               # trace all classes and functions in the system
    deny2trace4fetch()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                               # tailor trace for this test    
    # ------------------------------------------------------------------------------------------------- 
    # INITIALIZE MULTIPROCESSING MECHANISM JUST IN CASE
    # -------------------------------------------------------------------------------------------------    
    pipe2fetch = Pipe4Xi()
    queue2fetch = Queue4Xi()
    
    # ------------------------------------------------------------------------------------------------- 
    # INITIALIZE OPTIONAL CONSTANT MAIN INDEX HTML
    # -------------------------------------------------------------------------------------------------        
    ack2initialize4constant = False                                                                                  # True to test HTML file creation
    if ack2initialize4constant is True:
        # ==========================================================================================================
        # BUILD STATIC MAIN HTML FILE
        # ==========================================================================================================    
        path2index4all = None
        try:
            name2index4all = "index2xxxxxxxx4yo.html"                                                                # 
            path2index4all = folder2build4size + size2image4size + name2index4all
            print("(Step 0A12/33) OF MAIN BUILD2HYPERLINK4SIZE - SET PATH2INDEX4ALL TO: ", path2index4all)
            # 
            
        except:
            print("(Step 0A1Z2/33) OF MAIN BUILD2HYPERLINK4SIZE *** FAILED TO INITIALIZE PATH2INDEX4ALL: ", path2index4all)         
            #
                                
        fileobject4hyperlink = None
        try:
            fileobject4hyperlink = open(path2index4all,'w')
            print("(Step 0A13/33) OF MAIN BUILD2HYPERLINK4SIZE - OPENED OUTPUT: ", fileobject4hyperlink)
            # 
        except:
            print("(Step 0A1Z3/33) OF MAIN BUILD2HYPERLINK4SIZE *** FAILED TO OPEN OUTPUT: ", fileobject4hyperlink)         
            # 
        try:                
            fileobject4hyperlink.write('<html>\n')
            
            fileobject4hyperlink.write('<style type="text/css" media="all">\n')
            fileobject4hyperlink.write(' @import "https://www.yourdragonxi.org/css/halongbay.css";\n')
            fileobject4hyperlink.write('</style> \n')
            fileobject4hyperlink.write('<p>\n')
            fileobject4hyperlink.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4hyperlink.write('<br /><a id="000">yourdragon<b>&Xi;</b> @Content</a>\n')
            fileobject4hyperlink.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4hyperlink.write('<br /> \n')
            fileobject4hyperlink.write('<br /><b>&raquo;</b><a href="thumb/index2thumb4images.html" target="_blank">Thumb</a>\n')
            fileobject4hyperlink.write('<br /><b>&raquo;</b><a href="small/index2small4images.html" target="_blank">Small</a>\n')
            fileobject4hyperlink.write('<br /><b>&raquo;</b><a href="ipod/index2ipod4images.html" target="_blank">iPod</a>\n')
            fileobject4hyperlink.write('<br /><b>&raquo;</b><a href="medium/index2medium4images.html" target="_blank">Medium</a>\n')
            fileobject4hyperlink.write('<br /><b>&raquo;</b><a href="large/index2large4images.html" target="_blank">Large</a>\n')
            fileobject4hyperlink.write('<br /><b>&raquo;</b><a href="raw/index2raw4images.html" target="_blank">Raw</a>\n')
            fileobject4hyperlink.write('<br /><b>&raquo;</b><a href="raw/index2videos4images.html" target="_blank">Videos</a>\n')
            fileobject4hyperlink.write('<br /> \n')
            fileobject4hyperlink.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4hyperlink.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject4hyperlink.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /> \n')
            fileobject4hyperlink.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4hyperlink.write('<br />Small & Smart Inc reserves rights to change this document without any notice\n')
            fileobject4hyperlink.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject4hyperlink.write('</p>\n')
            # 
            fileobject4hyperlink.write('</html>\n')
        except:
            print("(Step 0A1Z4/33) OF MAIN BUILD2HYPERLINK4SIZE *** FAILED TO WRITE TO OUTPUT: ", fileobject4hyperlink)         
            #            
        try:    
            fileobject4hyperlink.close()
            print("(Step 0A15/33) OF MAIN BUILD2HYPERLINK4SIZE - CLOSED OUTPUT: ", fileobject4hyperlink)         
            #        
        except:
            print("(Step 0A1Z5/33) OF MAIN BUILD2HYPERLINK4SIZE *** FAILED TO CLOSE OUTPUT: ", fileobject4hyperlink)         
            #    
    else:
        # ==========================================================================================================
        # DYNAMICALLY BUILD HTML FILE USING SUBDIRECTORIES   
        # ==========================================================================================================
        path2index4all = None
        try:
            name2index4all = "index2xxxxxxxx4yo.html"
            # 
            path2index4all = folder2build4size + size2image4size + name2index4all
            print("(Step 1A/33) OF MAIN BUILD2HYPERLINK4SIZE - SET PATH2INDEX4ALL TO: ", path2index4all)
            # E://DRAGONXI//WebFaction//Web533//FTPWeb533//home//icefellow//webapps//yodragonxiorg//web//temp//images//l2s//index2xxxxxxxx4yo.html
            
        except:
            print("(Step 1Z/33) OF MAIN BUILD2HYPERLINK4SIZE *** FAILED TO INITIALIZE PATH2INDEX4ALL: ", path2index4all)         
            #                    
        fileobject4hyperlink = None
        try:
            fileobject4hyperlink = open(path2index4all,'w')
            print("(Step 2A/33) OF MAIN BUILD2HYPERLINK4SIZE - OPENED OUTPUT: ", fileobject4hyperlink)
            # <_io.TextIOWrapper name='E://DRAGONXI//WebFaction//Web533//FTPWeb533//home//icefellow//webapps//yodragonxiorg//web//temp//images//l2s//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>
            
        except:
            print("(Step 2Z1/33) OF MAIN BUILD2HYPERLINK4SIZE *** FAILED TO OPEN OUTPUT: ", fileobject4hyperlink)         
            # 
        try:                
            fileobject4hyperlink.write('<html>\n')
            
            fileobject4hyperlink.write('<style type="text/css" media="all">\n')
            fileobject4hyperlink.write(' @import "https://www.yourdragonxi.org/css/halongbay.css";\n')
            fileobject4hyperlink.write('</style> \n')
            fileobject4hyperlink.write('<p>\n')
            fileobject4hyperlink.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4hyperlink.write('<br /><a id="000">yourdragon<b>&Xi;</b> @Content</a>\n')
            fileobject4hyperlink.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject4hyperlink.write('<br /> \n')

        except:
            print("(Step 2Z2/33) OF MAIN BUILD2HYPERLINK4SIZE *** FAILED TO WRITE TO OUTPUT: ", fileobject4hyperlink)         
            #            

        
    # --------------------------------------------------------------------------------------------- 
    # START
    # ---------------------------------------------------------------------------------------------        
    print('=' *70)
    print("(Step 4A/33) OF MAIN BUILD2HYPERLINK4SIZE - VERSION 9.17.12.17 FOR ", path2read4xi, " WITH PROFILE: ", profile2fetch, " STARTED ", time4xi())
    # VERSION 9.17.12.17 FOR  E://DRAGONXI//WebFaction//Web533//FTPWeb533//home//icefellow//webapps//yodragonxiorg//web//temp//images//l2s//  WITH PROFILE:  {1: '.JPG', 2: '.jpg'}  
    # STARTED  04:35:13 02/03/17 FLE Standard Time
    
    print('=' *70)    
   
    pipe2fetch = Pipe4Xi()
    print("(Step 4B/33) OF MAIN BUILD2HYPERLINK4SIZE - PIPE2FETCH ", pipe2fetch)    
    # (<pipeconnection4xi.PipeConnection4Xi object at 0x0000000002F8A668>, <pipeconnection4xi.PipeConnection4Xi object at 0x0000000002F8A5C0>)
    queue2fetch = Queue4Xi()
    print("(Step 4C/33) OF MAIN BUILD2HYPERLINK4SIZE - QUEUE2FETCH ", queue2fetch)    
    # <queue4xi.Queue4Xi object at 0x0000000002F76C50>
    
    for file2walk in DirectoryWalker(path2read4xi):
        # ----------------------------------------------------------------------------------------- 
        #
        # -----------------------------------------------------------------------------------------     
        if os.path.isdir(file2walk):
            pass

        if os.path.isfile(file2walk):
            build2hyperlink4size(file2walk)
            
                        
    # --------------------------------------------------------------------------------------------- 
    # END
    # --------------------------------------------------------------------------------------------- 
    try:
        fileobject4hyperlink.write('<br /> \n')
        fileobject4hyperlink.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
        fileobject4hyperlink.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
        fileobject4hyperlink.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /> \n')
        fileobject4hyperlink.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
        fileobject4hyperlink.write('<br />Small & Smart Inc reserves rights to change this document without any notice\n')
        fileobject4hyperlink.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
        fileobject4hyperlink.write('</p>\n')
        # 
        fileobject4hyperlink.write('</html>\n')
    except:
        print("(Step 5Z1/33) OF MAIN BUILD2HYPERLINK4SIZE *** FAILED TO WRITE TO OUTPUT: ", fileobject4hyperlink)         
        #            
    try:    
        fileobject4hyperlink.close()
        print("(Step 5A/33) OF MAIN BUILD2HYPERLINK4SIZE - CLOSED OUTPUT: ", fileobject4hyperlink)         
        # 
        
    except:
        print("(Step 5Z2/33) OF MAIN BUILD2HYPERLINK4SIZE *** FAILED TO CLOSE OUTPUT: ", fileobject4hyperlink)         
        #    
                        
    # --------------------------------------------------------------------------------------------- 
    # RENAME IT, IF REQUIRED
    # --------------------------------------------------------------------------------------------- 
    if ack2rename4output is True:
        new2path4content = None
        try:
            print("(Step 6A/33) OF MAIN BUILD2HYPERLINK4SIZE - TRYING TO TO RENAME: ", path2index4all)
            # E://DRAGONXI//WebFaction//Web533//FTPWeb533//home//icefellow//webapps//yodragonxiorg//web//temp//images//l2s//index2xxxxxxxx4yo.html
            
            print("(Step 6B/33) OF MAIN BUILD2HYPERLINK4SIZE - USING PATH2READ4XI: ", path2read4xi)  
            # E://DRAGONXI//WebFaction//Web533//FTPWeb533//home//icefellow//webapps//yodragonxiorg//web//temp//images//l2s//
            
            
         
            len2size = len(size2image4size)
            size2xi = size2image4size[0:len2size-2]
            size4xi = str(size2xi) 
            if size4xi == "l2s":
                size4xi = "ls"        # large social media
            else:
                if size4xi == "m2s":  
                    size4xi = "ms"    # medium social media
                else:
                    pass              # cam, large,medium   
            print("(Step 6D/33) OF MAIN BUILD2HYPERLINK4SIZE - USING SIZE4XI: ", size4xi)
            # ls
            
            # FORMULA
            # ======================================================================================================        
            new2name4content = "all" + "2" + size4xi + "4yo" + ".html"
            new2path4content = folder2build4size + size2image4size + new2name4content
            # ======================================================================================================  
            #       
            
            print("(Step 6E/33) OF MAIN BUILD2HYPERLINK4SIZE - NEW2NAME4CONTENT SET TO: ", new2name4content) 
            # all2ls4yo.html

            print("(Step 6F/33) OF MAIN BUILD2HYPERLINK4SIZE - TRYING TO DELETE: ", new2path4content) 
            # E://DRAGONXI//WebFaction//Web533//FTPWeb533//home//icefellow//webapps//yodragonxiorg//web//temp//images//l2s//all2ls4yo.html
            
            try:
                os.remove(new2path4content)
                print("(Step 6G/33) OF MAIN BUILD2HYPERLINK4SIZE - DELETED: ", new2path4content) 
                # E://DRAGONXI//WebFaction//Web533//FTPWeb533//home//icefellow//webapps//yodragonxiorg//web//temp//images//l2s//all2ls4yo.html
                
            except:
                print("(Step 6H/33) OF MAIN BUILD2HYPERLINK4SIZE - DID NOT EXIST: ", new2path4content) 
                # 
                
            print("(Step 6I/33) OF MAIN BUILD2HYPERLINK4SIZE - TRYING TO RENAME: ", path2index4all) 
            # E://DRAGONXI//WebFaction//Web533//FTPWeb533//home//icefellow//webapps//yodragonxiorg//web//temp//images//l2s//index2xxxxxxxx4yo.html
            
            
            try:
                os.rename(path2index4all, new2path4content)
            
                print("(Step 6F/33) OF MAIN BUILD2HYPERLINK4SIZE - RENAMED TO: ", new2path4content)
                # E://DRAGONXI//WebFaction//Web533//FTPWeb533//home//icefellow//webapps//yodragonxiorg//web//temp//images//l2s//all2ls4yo.html
                
                
            except:
                print("(Step 6Z1/33) OF MAIN BUILD2HYPERLINK4SIZE *** FAILED TO RENAMED TO: ", new2path4content)
                #     
 
        except:
            print("(Step 6Z2/33) OF MAIN BUILD2HYPERLINK4SIZE *** FAILED TO RENAME: ", path2index4all, " TO: ", new2path4content)         
            #
            
        # --------------------------------------------------------------------------------------------- 
        # UPDATE FTP UPLOAD FOLDER
        # ---------------------------------------------------------------------------------------------         
        print("(Step 7A/33) OF MAIN BUILD2HYPERLINK4SIZE - TRYING TO COPY : ", new2path4content)
        # E://DRAGONXI//WebFaction//Web533//FTPWeb533//home//icefellow//webapps//yodragonxiorg//web//temp//images//l2s//all2ls4yo.html
        
                
        new2path4ftp = ftp2upload4size + new2name4content
        
        print("(Step 7B/33) OF MAIN BUILD2HYPERLINK4SIZE - FOR FTP AS : ", new2path4ftp)
        # E://DRAGONXI//PC4Xi//YoDragonXiOrg//WebSite//stock4xi//all2ls4yo.html
        
        
        try:
            copyfile(new2path4content, new2path4ftp)  
            print("(Step 7C/33) OF MAIN BUILD2HYPERLINK4SIZE - COPIED AND READY FOR FTP: ", new2path4ftp)
            # E://DRAGONXI//PC4Xi//YoDragonXiOrg//WebSite//stock4xi//all2ls4yo.html
            
                   
        except:
            print("(Step 7Z/33) OF MAIN BUILD2HYPERLINK4SIZE *** FAILED TO WRITE INTO FTP FOLDER : ", ftp2upload4size)
            #  
    else:
        pass        
        
    print('=' *75)
    print("(Step 8A/33) OF MAIN BUILD2HYPERLINK4SIZE - STATISTICS OF VERSION 9.17.12.18 FOR ", path2read4xi, " WITH PROFILE: ", profile2fetch, " COMPLETED  ", time4xi())
    # STATISTICS OF VERSION 9.17.12.18 FOR  E://DRAGONXI//WebFaction//Web533//FTPWeb533//home//icefellow//webapps//yodragonxiorg//web//temp//images//l2s//
    # WITH PROFILE:  {1: '.JPG', 2: '.jpg'}  
    # COMPLETED   04:35:14 02/03/17 FLE Standard Time
         
    # ---------------------------------------------------------------------------------------------    
    # Print Trace
    # ---------------------------------------------------------------------------------------------     
    print ('(Step 0J/33) OF MAIN BUILD2HYPERLINK4SIZE - PRINTING TRACE WITH T2XI', t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    print_trace4xi(t2xi)        
    print ('(Step 0K/33) OF MAIN BUILD2HYPERLINK4SIZE - PRINTED TRACE WITH T2XI', t2xi)           
    
#</function4xi>
    
        
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()        
#</target4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# L:\temp\txt\build2hyperlink4size.txt
# E:\Studio4Xi\web\xml\ace-build2hyperlink4size.xml
# E:\Studio4Xi\web\xml\reason-build2hyperlink4size.xml
# E:\Studio4Xi\web\xml\sense-build2hyperlink4size.xml
# 
#"
#>
#     
# 
# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of build2hyperlink4size.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

